module ExPag62 (
		module ExPag62,
		module Net,
		module SimpleNet,
		module TransSystem,
		module ST,
		module Relation
	       ) where

import Net
import SimpleNet
import TransSystem
import ST
import Relation

---------------------------------------------------------------------------------------------------
-- Exemplo da Pgina 62 dos apontamentos
--------------------------------------------------------------------------------------------------

data Pos = Pos Int
	   deriving (Eq, Show, Read)

data Act = Act Int
	 deriving (Eq, Show, Read)


instance Spanned Pos where
      s_span   = map Pos [0..5]

instance Spanned Act where
      s_span   = map Act [0..2] 



myF, myB :: Act -> Bag Pos

myF a = case a of {
          Act 0  -> Bag (\p -> case p of { Pos 0 -> 1 ; Pos 1 -> 1 ; _ -> 0 }) ;
          Act 1  -> Bag (\p -> case p of { Pos 1 -> 1 ; Pos 3 -> 1 ; _ -> 0 }) ;
          Act 2  -> Bag (\p -> case p of { Pos 1 -> 1 ; Pos 4 -> 1 ; _ -> 0 }) 
	          }


myB a = case a of {
          Act 0  -> Bag (\p -> case p of { Pos 2 -> 1 ; Pos 3 -> 1 ; _ -> 0 }) ;
          Act 1  -> Bag (\p -> case p of { Pos 4 -> 1 ;              _ -> 0 }) ;
          Act 2  -> Bag (\p -> case p of { Pos 5 -> 1 ;              _ -> 0 }) 
	          }

limits :: Bag Pos
limits = Bag (\_ -> 1)

exPag62 :: SimpleNet Pos Act  (Bag Pos) [Act]
exPag62 = SimpleNet myF myB limits


initial_cut :: Bag Pos
initial_cut =listToBag [(Pos 0,1),(Pos 1,1)]

transition_      = transition exPag62
path_            = path exPag62
explode_         = explode exPag62
accessibles_     = accessibles exPag62


-- explode_ `on` initial_cut
-- map (posOn . snd) it

-- accessibles_ `on` initial_cut
-- map posOn it


cuts = map posOn (accessibles_ `on` initial_cut)
