module ProdCons (
		module ProdCons,
		module Net,
		module SimpleNet,
		module TransSystem,
		module ST,
		module Relation
	       ) where

import Net
import SimpleNet
import TransSystem
import ST
import Relation

---------------------------------------------------------------------------------------------------
-- Exemplo do produtor-consumidor
--------------------------------------------------------------------------------------------------

data Pos = AtProduz | AtEntrega | Vazio | Cheio | AtRecebe | AtConsome
	   deriving (Eq, Show, Read)

data Act = Produz | Entrega | Recebe | Consome
	 deriving (Eq, Show, Read)

instance Spanned Pos where
      s_span   = [ AtProduz , AtEntrega , Vazio , Cheio , AtRecebe , AtConsome ]

instance Spanned Act where
      s_span = [ Produz , Entrega , Recebe , Consome ]



myF, myB :: Act -> Marks Pos

myF a = case a of {
          Produz  -> Bag (\p -> case p of { AtProduz   -> 1              ; _ -> 0 }) ;
          Entrega -> Bag (\p -> case p of { AtEntrega  -> 1 ; Vazio -> 1 ; _ -> 0 }) ;
          Recebe  -> Bag (\p -> case p of { AtRecebe   -> 1 ; Cheio -> 1 ; _ -> 0 }) ;
          Consome -> Bag (\p -> case p of { AtConsome  -> 1              ; _ -> 0 })
	              }


myB a = case a of {
          Produz  -> Bag (\p -> case p of { AtEntrega -> 1               ; _ -> 0 }) ;
          Entrega -> Bag (\p -> case p of { AtProduz  -> 1 ; Cheio  -> 1 ; _ -> 0 }) ;
          Recebe  -> Bag (\p -> case p of { AtConsome -> 1 ; Vazio  -> 1 ; _ -> 0 }) ;
          Consome -> Bag (\p -> case p of { AtRecebe  -> 1               ; _ -> 0 })
	          }


limits :: Marks Pos
limits = Bag (\_ -> 1)

prodCons :: SimpleNet Pos Act  (Bag Pos) [Act]
prodCons = SimpleNet myF myB limits


inicio :: Marks Pos
inicio =listToBag [(AtProduz,1),(Vazio,1),(AtRecebe,1)]

transition_      = transition prodCons
path_            = path prodCons
explode_         = explode prodCons
accessibles_     = accessibles prodCons


-- explode_ `on` inicio
-- map (posOn . snd) it

-- transition_ [Produz] >> explode_ `on` inicio
-- map (posOn . snd) it

-- path_ [[Produz],[Recebe]] `on` inicio
-- map (posOn . snd) it

-- accessibles_ `on` inicio
-- map posOn it
