module SimpleNet (module SimpleNet) where

import Net
import Relation
import MMonad

---------------------------------------------------------------------------------------------------

type  Marks p = Bag p

instance (Spanned p) => State (Marks p) where
     sminus m u = u >>= return . merge (-) m 
     splus  m u = u >>= return . merge (+) m

instance (Spanned a) => Transition [a]

--------------------------------------------------------------------------------------------------------

data (Spanned a, Spanned p, State s, Transition t) => SimpleNet p a s t =
      SimpleNet { mF :: a -> Marks p , mB :: a -> Marks p , limit :: Marks p}

instance (Spanned p, Spanned a)  => Net (SimpleNet p a) (Marks p) [a] where
       fwrd n = accumulate n (mF n)
       bwrd n = accumulate n (mB n)

-------
-- auxiliar functions 
-------

merge :: (Spanned p) => (Int -> Int -> Int) -> (Marks p) -> (Marks p) ->  Marks p
merge f u v = Bag w   where  w p = f (bags u p) (bags v p)

posOn :: (Spanned p) => (Marks p) -> [p]
posOn m = filter ((>0) . bags m) s_span

accumulate :: (Spanned a, Spanned p) =>
	      SimpleNet p a (Marks p) [a] -> (a -> Marks p) -> [a] -> [Marks p]
accumulate n f t = foldr (splus . f) [bot] t `ifIs` (.<. limit n)



