module TransSystem (module TransSystem) where

import ST
import Relation

class (Eq s) => TransSystem n s t  where
    transition :: n s t -> t -> ST [] s s
    trans_set  :: n s t -> [t]
--
    path :: n s t -> [t] -> ST [] s s
    path n = foldl step idT where
	       step u t = u >> transition n t 
	       idT      = delta (return . id)
--
    choices ::  n s t -> [t] -> ST [] s (t,s)
    choices n = foldl step mzero  where
	       step u t = u `mplus` (fmap (\x -> (t,x)) (transition n t)) 
--
    explode :: n s t ->  ST [] s (t,s)
    explode n = choices n (trans_set n)
--
    accessibility :: n s t -> s -> [s]
    accessibility = cover . on . get snd . explode
--
    accessibles :: n s t -> ST [] s s
    accessibles = delta . accessibility
--
    state_transition_diagram :: (Eq s) => n s t -> ST [] s (s,t,s)
    state_transition_diagram n = do s <- accessibles n ; (t,u) <-  explode n ; return (s,t,u)
--
    nolock:: n s t ->  ST [] s ()
    nolock n = explode n >> return ()
--
